; HISTORY
;  [2]	 4-Sep-84  David Medinets (dm) at unipress
;	I have checked what-cursor-position vs.   the DEC-20  BLUE and it
;	looks to be working very well except that  the buffer-lengths are
;	different between the two systems.
;
;  [1]	 4-Sep-84  David Medinets (dm) at unipress
;	Steve Friedl made line-number into a C function so I have deleted
;	the mlisp definition here.
;	in general, I tried to made the code more clear and redid some of
;	the messages so that they are more human.
;	in What-cursor-position I changed the ?   to 100  when the buffer
;	is empty.
;
;Copyright (c) 1984 - Community Data Processing
;sw: 7/9/84: miscellaneous functions to provide tops-20 semantics

(declare-global &misc-tops-is-loaded)
(setq &misc-tops-is-loaded 1)

(defun
    (exit-recursive-edit
	(if (= (recursion-depth) 0)
	    (error-message "Not in a recursive edit")
	    (exit-emacs)
	)
     )

    (what-cursor-position pos char
       (setq pos  (- (dot) 1))
       (setq char (if (!= 0 (buffer-size))
                     (if (!= pos (buffer-size)) 
                        (concat " CH=" (following-char)))
                     ""
		  )
       )
       (message "X="  (- (current-column) 1)
                " Y=" (- (line-number) 1)
                char
 	        " .="  pos
                "(" (if (= 0 (buffer-size))
                       "0"
                       (/ (* pos 100) (buffer-size)))
		"% of " (buffer-size)    ")"
		(if (!= char "") 
                   " CH is in decimal instead of octal, sorry!"
                   ""
		)
       )
    )
; 
;tops-20 case changing:
;   only change the characters after dot
;   prefix-arg is active:
;	arg>0 : do next arg words
;	arg=0 : do this word, and return cursor to same place
;	arg<0 : do previous arg words
;   leave dot after the last word changed (except for arg=0)
; 
   (&case-change arg start		;pass gosling case, and prefix arg
      (setq start (dot))			;remember where we start
      (if (< (setq arg (arg 2)) 0)	;working on previous words?
	 (progn				;then go backwards
	    (setq arg (- 0 arg))	;make it pos for future use
	    (provide-prefix-argument arg (backward-word)))
	 (if (looking-at "\\W")		;between words?
	    (progn
	       (error-occurred (re-search-forward "\\w")) ;get to next one
	       (backward-character)	;and move to first char
	    )
	 )
      )
      (insert-character ' ')		;build fence to isolate previous chars
      (provide-prefix-argument arg (arg 1)) ;change case
      (delete-previous-character)		;toss our fence
      (goto-character start)		;back to where we started
      (if (> (arg 2) 0)			;positive?
	 (provide-prefix-argument (arg 2) (forward-word))
      )
   )

   (uppercase-initial (&case-change (case-word-capitalize) prefix-argument))
   (lowercase-word    (&case-change (case-word-lower)      prefix-argument))
   (uppercase-word    (&case-change (case-word-upper)      prefix-argument))
; 
; indentation stuff
; 
   (back-to-indentation
      (beginning-of-line)
      (if (! (error-occurred (re-search-forward "[^ 	]"))) ;non-delim?
	 (backward-character)		;then get in front of it
      )
      (novalue)
   )
; 
; merge current-line with the previous-line
;  a prefix argument means merge next line with this one
; 
   (delete-indentation
      (if prefix-argument-provided (next-line))
      (beginning-of-line)			;to front of line
      (delete-previous-character)		;delete newline
      (delete-white-space)			;toss all delimiters
      (insert-character ' ')			;add a space
      (novalue)
   )

   (set-right-margin margin		;set to prefix argument, else dot
      (message "Type 'y' to set the right margin to "
	 (setq margin
              (if prefix-argument-provided prefix-argument (current-column))
	 )
      )
   (if (= (get-tty-character) 'y')
      (message "The margin has been  set to " (setq right-margin margin))
      (error-message "Aborted")
   )
   )

   (move-to-screen-edge		;center, else prefix-arg from top
      (beginning-of-window)
      (provide-prefix-argument
         (if prefix-argument-provided prefix-argument (/ (window-height) 2))
            (next-line)
	 )
   )
)
